routes/web.php
<?php

use App\Http\Controllers\back\NoticiaController as BackNoticiaController;
use App\Http\Controllers\front\NoticiaController as FrontNoticiaController;
use App\Http\Controllers\NoticiaController;
use App\Http\Controllers\ProfileController;
use Illuminate\Support\Facades\Route;



//controlador de recursos que pueden ver todos los usuarios
//Route::resource('noticias', NoticiaController::class);

//se pone antes de las de recursos para que no salte el middleware
//si lo pongo debajo sale la autenticacion
//ruta pagina de inicio del front
//muestra algunos campos de las noticias y para pinchar para verla completa
//quiero que salga en el menu Panel, login y registrar

Route::controller(FrontNoticiaController::class)->group(function () {
    //muestra todas las noticias
    Route::get('/', 'index')->name('home');
    //muestra una sola noticia
    Route::get('front/noticias/{noticia}', 'show')->name('front.noticias.show');
    //ruta para el buscador
    Route::post('front/noticias/buscar', 'buscar')->name('front.noticias.buscar');
});

//los usuarios autenticados pueden acceder a estas rutas
Route::middleware('auth')->group(function () {
    //pagina de inicio del back
    //quiero ver la informacion del usuario
    //si pincho en el icono del menu me lleva al front
    //que muestre en el menu Gestion de noticias, crear noticia, noticias de usuartio y editar noticia
    //un dropdown para perfil o cerrar sesion
    Route::get('/back/index', function () {
        return view('back.index');
    })->name('back.index');

    Route::get('/profile', [ProfileController::class, 'edit'])
        ->name('profile.edit');

    Route::patch('/profile', [ProfileController::class, 'update'])
        ->name('profile.update');

    Route::delete('/profile', [ProfileController::class, 'destroy'])
        ->name('profile.destroy');

    //para mostrar las noticias del usuario logueado
    Route::controller(BackNoticiaController::class)->group(function () {
        Route::get('/back/noticias/listado', 'listado')->name('back.noticias.listado');
    });

    //para la gestion de las noticias
    Route::resource('back/noticias', BackNoticiaController::class)
        ->names('back.noticias');
});



require __DIR__ . '/auth.php';

app/Models/Noticia.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class Noticia extends Model
{
    use HasFactory;

    //nombre de la tabla
    protected $table = 'noticias';

    //campos para la asignacion masiva
    protected $fillable = [
        'user_id',
        'titulo',
        'contenido',
        'foto',
    ];
    

    //relaciona la noticia creada con el id del usuario
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class, 'user_id');
    }
}

app/Http/Controllers/back/NoticiaController.php
<?php

namespace App\Http\Controllers\back;

use App\Http\Controllers\Controller;
use App\Models\Noticia;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;

class NoticiaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //Auth es un facade de laravel (un helper)
        //Auth::user(); //devuelve el usuario autenticado
        //Auth::check(); //devuelve true si el usuario esta autenticado
        //Auth::guest(); //devuelve true si el usuario NO esta autenticado
        //Auth::user()->user_id; //devuelve el id del usuario
        //Auth::user()->name; //devuelve el nombre del usuario

        //obtengo todas las noticias
        $noticias = Noticia::paginate(5);
        //redireciono a la vista back.noticias.index
        return view('back.noticias.index', compact('noticias'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('back.noticias.create', ['noticia' => new Noticia()]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //subir la foto
        $fotoSubida = $request->file('foto');

        //almacenamos la foto
        $foto = $fotoSubida->store('fotos', 'public');

        //crear la noticia con fill y save
        $noticia = new Noticia();
        $noticia = $noticia->fill($request->all());
        //metemos el usuario autenticado
        $noticia->user_id = Auth::user()->id;
        $noticia->foto = $foto;
        $noticia->save();
        //redireccionar
        return redirect()->route('back.noticias.show', $noticia);
    }

    /**
     * Display the specified resource.
     */
    public function show(Noticia $noticia)
    {
        return view('back.noticias.show', compact('noticia'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Noticia $noticia)
    {
        //comprobamos que el usuario es el dueño de la noticia
        if ($noticia->user_id != Auth::user()->id) {
            abort(403, 'No tienes permisos para editar esta noticia');
        }
        return view('back.noticias.edit', compact('noticia'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Noticia $noticia)
    {
        //comprobamos si ha subido un fichero
        if ($request->hasFile('foto')) {

            //recupreamos la foto vieja
            $fotoSubida = $noticia->foto;
            //eliminamos la foto vieja
            Storage::disk('public')->delete($noticia->foto);
            //almaceno la nueva foto
            $fotoSubida = $request->file('foto')->store('fotos', 'public');
            //actualizo la noticia
            $noticia->fill($request->all());
            $noticia->foto = $fotoSubida;
        } else {
            //actualizo la noticia
            $noticia->fill($request->all());
        }
        $noticia->user_id = Auth::user()->id;
        $noticia->save();

        return redirect()->route('back.noticias.show', $noticia);
        
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Noticia $noticia)
    {
        //comprobamos que el usuario es el dueño de la noticia
        if ($noticia->user_id != Auth::user()->id) {
            abort(403, 'No tienes permisos para eliminar esta noticia');
        }
        //eliminamos la foto
        Storage::disk('public')->delete($noticia->foto);
        //eliminamos la noticia
        $noticia->delete();
        //redireccionamos
        return redirect()->route('back.noticias.index');
    }

    //para mostrar las noticias del usuario logueado     
    public function listado()
    {
        //obtengo las noticias del usuario logueado
        $noticias = Noticia::where('user_id', Auth::user()->id)->get();

        return view('back.noticias.listado', compact('noticias'));
    }
}

app/Http/Controllers/front/NoticiaController.php
<?php

namespace App\Http\Controllers\front;

use App\Http\Controllers\Controller;
use App\Models\Noticia;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class NoticiaController extends Controller
{

    /* 
    * funcion para listar las noticias
    * accesible para todos
    * no deben aparecer los botones de edicion
    * solo uno para ver la norticia completa (show)
    */
    public function index()
    {
        //obtengo todas las noticias
        $noticias = Noticia::paginate(5);
        //renderizo la vista en la vista front.index
        return view('front.index', compact('noticias'));
    }

    /**
     * Display the specified resource.
     */
    public function show(Noticia $noticia)
    {
        return view('front.noticias.show', compact('noticia'));
    }

    public function buscar(Request $request)
    {
        $noticias = Noticia::where('titulo', 'like', '%' . $request->busqueda . '%')
            ->orWhere('contenido', 'like', '%' . $request->busqueda . '%')
            ->paginate(5);
        return view('front.index', compact('noticias'));
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;
use Illuminate\View\View;

class AppLayout extends Component
{
    /**
     * Este componente lo utilizamos como layaut para las vistas del back
     */
    public function render(): View
    {
        return view('layouts.app');
    }
}

resources/views/back/noticias/create.blade.php
<x-app-layout>
    <div>
        <div class="mb-4">
            <h1 class="text-white">Crear nueva noticia</h1>
        </div>
        <div class="mb-4">
            <form action="{{ route('back.noticias.store') }}" method="post" enctype="multipart/form-data">
                @csrf
                @include('components.mios._form')
            </form>
        </div>
    </div>
</x-app-layout>

resources/views/back/noticias/edit.blade.php
<x-app-layout>
    <div>
        <h1>Actualizar noticia</h1>
    </div>
    <div class="tarjeta">
        <form action="{{ route('back.noticias.update',$noticia) }}" method="post" enctype="multipart/form-data">
            @csrf
            @method('PUT')
            @include('components.mios._form')
        </form>
    </div>   
</x-app-layout>

resources/views/back/noticias/index.blade.php
<x-app-layout>
    <div>
        @foreach ($noticias as $noticia)
            <div
                class="flex items-start gap-4 rounded-lg bg-white p-6 shadow-[0px_14px_34px_0px_rgba(0,0,0,0.08)] ring-1 ring-white/[0.05] transition duration-300 hover:text-black/70 hover:ring-black/20 focus:outline-none focus-visible:ring-[#FF2D20] lg:pb-10 dark:bg-zinc-900 dark:ring-zinc-800 dark:hover:text-white/70 dark:hover:ring-zinc-700 dark:focus-visible:ring-[#FF2D20]">
                <div class="flex size-12 shrink-0 items-center justify-center bg-[#FF2D20]/10 sm:size-16">
                    <img src="{{ asset('storage/' . $noticia->foto) }}" alt="">
                </div>
                <div class="pt-3 sm:pt-5">
                    <h2 class="text-xl font-semibold text-black dark:text-white">
                        {{-- mostrar el titulo --}}
                        {{ $noticia->titulo }}
                    </h2>

                    <p class="mt-4 text-sm/relaxed text-white">
                        {{-- mostrar los 100 primeros caracteres seguida de ... --}}
                        {{ Str::limit($noticia->contenido, 100, '...') }}
                    </p>
                    <div class="mt-4 text-blue-400 text-sm text-left">
                        {{-- mostrar el nombre del usuario i la fecha de actualizacion --}}
                        Creado por: {{ $noticia->user->name }}
                        <br>
                        Última actualización: {{ $noticia->updated_at->format('d/m/Y' . ' ' . 'H:i') }}
                    </div>
                </div>
                {{-- comprobamos si el usuario es el dueño de la noticia --}}
                @if ($noticia->user_id == Auth::user()->id)
                <div class="mt-4 text-blue-400">
                    <a href="{{ route('back.noticias.show', $noticia) }}" class="boton">Ver</a>
                    <a href="{{ route('back.noticias.edit', $noticia) }}" class="boton">Editar</a>
                    <form action="{{ route('back.noticias.destroy', $noticia) }}" method="post" id="eliminar">
                        @csrf
                        @method('delete')
                        <button type="submit" class="boton">Borrar</button>
                    </form>
                </div>
                @else
                <div class="mt-4 text-blue-400">
                    <a href="{{ route('back.noticias.show', $noticia) }}" class="boton">Ver</a>
                </div>
                @endif
            </div>
        @endforeach
        <div>
            {{ $noticias->links() }}
        </div>
    </div>
</x-app-layout>

resources/views/back/noticias/listado.blade.php
<x-app-layout>
    @foreach ($noticias as $noticia)
        <div
            class="flex items-start gap-4 rounded-lg bg-white p-6 shadow-[0px_14px_34px_0px_rgba(0,0,0,0.08)] ring-1 ring-white/[0.05] transition duration-300 hover:text-black/70 hover:ring-black/20 focus:outline-none focus-visible:ring-[#FF2D20] lg:pb-10 dark:bg-zinc-900 dark:ring-zinc-800 dark:hover:text-white/70 dark:hover:ring-zinc-700 dark:focus-visible:ring-[#FF2D20]">
            <div class="flex size-12 shrink-0 items-center justify-center sm:size-16">
                <img src="{{ asset('storage/' . $noticia->foto) }}" alt="">
            </div>
            <div class="pt-3 sm:pt-5">
                <h2 class="text-xl font-semibold text-black dark:text-white">
                    {{-- mostrar el titulo --}}
                    {{ $noticia->titulo }}
                </h2>
                <p class="mt-4 text-sm/relaxed text-white">
                    {{-- mostrar los 100 primeros caracteres seguida de ... --}}
                    {{ Str::limit($noticia->contenido, 100, '...') }}
                </p>
                <div class="mt-4 text-blue-400 text-sm text-left">
                    {{-- mostrar el nombre del usuario i la fecha de actualizacion --}}
                    Creado por: {{ $noticia->user->name }}
                    <br>
                    Última actualización: {{ $noticia->updated_at->format('d/m/Y' . ' ' . 'H:i') }}
                </div>
            </div>
            <div class="mt-4 text-blue-400 text-right">
                <a href="{{ route('back.noticias.show', $noticia) }}" class="boton">Ver</a>
                <a href="{{ route('back.noticias.edit', $noticia) }}" class="boton">Editar</a>
                <form action="{{ route('back.noticias.destroy', $noticia) }}" method="post" id="eliminar">
                    @csrf
                    @method('delete')
                    <button type="submit" class="boton">Borrar</button>
                </form>
            </div>
        </div>
    @endforeach
</x-app-layout>

resources/views/back/noticias/show.blade.php
<x-app-layout>
    {{-- ponemos la imagen de la noticia encima del texto --}}
    <div class="mt-4 flex size-60 shrink-0 items-center justify-center bg-[#FF2D20]/10 ">
        <img src="{{ asset('storage/' . $noticia->foto) }}" alt="">
    </div>
    <div class="pt-3 sm:pt-5">
        <h2 class="text-xl font-semibold text-black dark:text-white">
            {{-- mostrar el titulo --}}
            {{ $noticia->titulo }}
        </h2>
        <p class="mt-4 text-sm/relaxed text-white">
            {{-- mostrar los 100 primeros caracteres seguida de ... --}}
            {{ $noticia->contenido }}
        </p>
        <div class="mt-4 text-sm text-center">
            {{-- mostrar el nombre del usuario i la fecha de actualizacion --}}
            <div class="text-blue-400 capitalize">Creado por:{{ $noticia->user->name }}</div>
            <div class="text-blue-400">Fecha de creación: {{ $noticia->created_at->format('d/m/Y') }}</div>
            <div class="text-blue-400">Fecha de actualización {{ $noticia->updated_at->format('d/m/Y') }}</div>
        </div>
        <div class="mt-4 text-blue-400">
            <a href="{{ route('back.noticias.edit', $noticia) }}" class="boton">Editar</a>
            <form action="{{ route('back.noticias.destroy', $noticia) }}" method="post" id="eliminar">
                @csrf
                @method('delete')
                <button type="submit" class="boton">Borrar</button>
            </form>
        </div>
    </div>
</x-app-layout>